#AutoIt3Wrapper_UseX64=y
#include '..\Include\advlcd.au3'
#include '..\Include\Bass.au3'
#include <GDIPlus.au3>

OnAutoItExitRegister('OnExit')
_GDIPlus_Startup()
LcdInitialize()
_BASS_STARTUP()
Global $sLength = '0', $iBarWidth, $hApplet, $hBuffer, $dStruct, $iPtr, $ahPen2[550], $iStringWidth, $hBitmap, $hBass, $hPixmap, $iLength, $iL, $iR, $iNow, $hBar, $hSlider, $hClone, $iLevel, $sFile
$hApplet = LcdCreateApplet('Equalizer')
Global $ahGrey[4] = [_GDIPlus_PenCreate(0xFFBBBBBB), _GDIPlus_PenCreate(0xFF888888), _GDIPlus_PenCreate(0xFF777777), _GDIPlus_PenCreate(0xFF444444)]
$hBitmap = _GDIPlus_BitmapCreateFromFile(@ScriptDir & '\Bitmap.bmp')
$hBuffer = _GDIPlus_ImageGetGraphicsContext($hBitmap)
_BASS_Init(0, -1, 44100, 0, '')
$sFile = FileOpenDialog('MediaPlayer', @DesktopDir & '\', 'Musik (*.*)')
$hBass = _BASS_StreamCreateFile(False, $sFile, 0, 0, 0)
LcdSetTarget($hApplet, 0)
LcdWaitActivation($hApplet)
$iLength = _BASS_ChannelGetLength($hBass, $BASS_POS_BYTE)
_BASS_ChannelPlay($hBass, 1)

$sLength = _SecFormat($hBass, $iLength)
$iStringWidth = LcdStringWidth($hApplet, $sLength)
$iBarWidth = 308 - 2 * $iStringWidth

$dStruct = DllStructCreate('float[128]')
$iPtr = DllStructGetPtr($dStruct)

Global $ahPen1[41] = [_GDIPlus_PenCreate(0xFF00FF00)]
Global $ahPen3[6] = [_GDIPlus_PenCreate(0xFF333333), _GDIPlus_PenCreate(0xFF151515), _GDIPlus_PenCreate(0xFF9A9A9A), _GDIPlus_PenCreate(0xFF707070), _GDIPlus_PenCreate(0xFFCCCCCC), _GDIPlus_PenCreate(0xFF999999)]

For $i = 1 To 40
	$ahPen1[$i] = _GDIPlus_PenCreate(0xFF000000 + Int($i * 6.375) * 0x10000 + Int($i * - 6.375) * 0x100)
Next

For $i = 0 To 549
	$ahPen2[$i] = _GDIPlus_PenCreate(_GetColor($i))
Next

_GDIPlus_GraphicsDrawRect($hBuffer, 0, 0, $iBarWidth - 1, 4, $ahPen3[0])
_GDIPlus_GraphicsDrawLine($hBuffer, 1, 5, $iBarWidth - 2, 5, $ahPen3[1])
_GDIPlus_GraphicsDrawRect($hBuffer, 1, 1, $iBarWidth - 3, 1, $ahPen3[2])
_GDIPlus_GraphicsDrawRect($hBuffer, 1, 3, $iBarWidth - 3, 1, $ahPen3[3])
$hBar = _GDIPlus_BitmapCloneArea($hBitmap, 0, 0, $iBarWidth, 6)

_GDIPlus_GraphicsDrawRect($hBuffer, 0, 0, 3, 13, $ahPen3[0])
_GDIPlus_GraphicsDrawRect($hBuffer, 1, 1, 1, 5, $ahPen3[4])
_GDIPlus_GraphicsDrawRect($hBuffer, 1, 7, 1, 5, $ahPen3[5])
$hSlider = _GDIPlus_BitmapCloneArea($hBitmap, 0, 0, 4, 14)

For $i = 0 To 5
	_GDIPlus_PenDispose($ahPen3[$i])
Next

While Sleep(10)
	$iNow = _BASS_ChannelGetPosition($hBass, $BASS_POS_BYTE)
	_BASS_ChannelGetData($hBass, $iPtr, $BASS_DATA_FFT256)
	$iLevel = _BASS_ChannelGetLevel($hBass)
	DrawBMP(($iNow / $iLength) * $iBarWidth, $iLevel)
	$hPixmap = LcdLoadPixmap(@TempDir & '\Equalizer.bmp')
	LcdDrawPixmap($hApplet, $hPixmap)
	LcdDrawText($hApplet, $sLength, 317 - $iStringWidth, 3)
	LcdDrawText($hApplet, _SecFormat($hBass, $iNow), 3, 3)
	LcdUpdate($hApplet, 0)
	LcdDeletePixmap($hPixmap)
WEnd

Func DrawBMP($iProcess, $iLvl)
	$iL = -Int(_BASS_HiWord($iLvl) / 819.2)
	$iR = Int(_BASS_LoWord($iLvl) / 819.2)
	$hClone = _GDIPlus_BitmapCloneArea($hBitmap, 1, 20, 319, 220)
	_GDIPlus_GraphicsClear($hBuffer, 0xFF000000)
	For $i = $iL To $iR
		_GDIPlus_GraphicsDrawLine($hBuffer, 319, 66 + $i, 320, 66 + $i, $ahPen1[Abs($i)])
	Next
	For $i = 1 To 128
		_GDIPlus_GraphicsDrawLine($hBuffer, 319, 241 - $i, 320, 241 - $i, $ahPen2[Int((DllStructGetData($dStruct, 1, $i) ^ 0.3) * 510)])
	Next
	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hBar, $iStringWidth + 6, 9, $iBarWidth, 6)
	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hSlider, 6 + $iStringWidth + $iProcess, 5, 4, 14)
	_GDIPlus_GraphicsDrawImageRect($hBuffer, $hClone, 0, 20, 319, 220)
	_GDIPlus_BitmapDispose($hClone)
	_GDIPlus_ImageSaveToFile($hBitmap, @TempDir & '\Equalizer.bmp')
EndFunc   ;==>DrawBMP

Func OnExit()
	For $i = 1 To 40
		_GDIPlus_PenDispose($ahPen1[$i])
	Next
	For $i = 0 To 549
		_GDIPlus_PenDispose($ahPen2[$i])
	Next
	_GDIPlus_Shutdown()
	LcdDeleteApplet($hApplet)
	LcdDeInitialize()
EndFunc   ;==>OnExit

Func _GetColor($iV)
	If $iV <= 0xFF Then
		Return 0xFF000000 + $iV * 0x10000
	ElseIf $iV <= 0x1FE Then
		Return 0xFFFF0000 + ($iV - 0xFF) * 0x100
	Else
		Return 0xFFFFFF00
	EndIf
EndFunc   ;==>_GetColor

Func _SecFormat($hMusic, $iBytes)
	Local $iSeconds = _BASS_ChannelBytes2Seconds($hMusic, $iBytes)
	If StringLen(String(Mod(Int($iSeconds), 60))) = 1 Then Return String(Floor($iSeconds / 60)) & ':0' & String(Mod(Int($iSeconds), 60))
	Return String(Floor($iSeconds / 60)) & ':' & String(Mod(Int($iSeconds), 60))
EndFunc   ;==>_SecFormat
